*+
*+
*+    Source Module => GETDATE2.PRG
*+
*+    Functions: Procedure tmp()
*+               Function GetDate2()
*+               Static Function MyDtoC()
*+               Function SplitColor()
*+
*+    Reformatted by Click! 1.13b3 on May-25-1998 at  2:26 pm
*+
*+

// -------------------------- Sample procedure ----------------*

*+
*+
*+    Procedure tmp()
*+
*+
*+
procedure tmp

local d        := ctod( "" )
local lLog     := .t.
memvar getlist

setcolor( "w+/b,n/bg,,,N/bg" )
clear screen
set epoch to 1950   // to force YY = "10" to be "2010", not "1910"

do while lastkey() <> 27
   scroll( 4, 0, 5, 79 )
   @  1,  1 say "Give a date"         
   d := getDate2( d, 1, 13 )            // getDate2(date, row, col)
   // getDate2(@d, 1, 13)     // other possibility

   @  4,  1 say "your date : " + dtoc( d ) ;         
           + ", your year : " + str( year( d ), 4 ) ;
           + " (set epoch : " + str( set( _SET_EPOCH ), 4 ) + ")"

   @  5,  1 say "Is that what you wanted ?" get lLog picture "Y"       
   read

   devpos( 4, 1 )
   ??

end

clear screen

return
// -------------------------- End of sample procedure ----------------*

// ---------------------------------- GetDate2 --------------------------------*
//                                    
//    Split the date to cDDMM (or cMMDD, it's equal), display it with the correct
//    century (be carefull with set epoch), get the new one and make it back to
//    a date. If the date is invalid, makes a BIP and ask again (you can change
//    tone(200,3) to anything else you like).
//
//    Calls : splitcolor

*+
*+
*+    Function GetDate2()
*+
*+    Called from ( getdate2.prg )   1 - procedure tmp()
*+
*+
*+
function GetDate2( d, nRow, nCol )

local cD            // to make no perturbation in your current READ// Part of my personal lib
local getlist     := {}                 // to make no perturbation in your current READ// Part of my personal lib
local lOldConfirm := set( _SET_CONFIRM, .f. )               // to make no perturbation in your current READ// Part of my personal lib
local cDDMM       := "    "             // to make no perturbation in your current READ// Part of my personal lib
local cCC         := "  "               // to make no perturbation in your current READ// Part of my personal lib
local cYY         := if( empty( d ), "  ", right( str( year( d ) ), 2 ) )       // to make no perturbation in your current READ// Part of my personal lib
local cColorGet   := splitcolor() [2]   // to make no perturbation in your current READ// Part of my personal lib

// In this case, it just pick the get-color
// (colorselect() would probably makes the job, in a
// different way)

#ifndef _GETEXIT_CH
#include "getexit.ch"
#endif

@ nRow, nCol get cDDMM ;         
        when MyDtoC( d, @cDDMM, @cCC, @cYY, nRow, nCol, cColorGet ) ;
        picture "@R 99/99"

@ nRow, nCol + 5 say "/" + cCC color cColorGet //century (disp before the GET)        

@ nRow, nCol + 8 get cYY ;         
        valid ( d := ctod( stuff( cDDMM, 3, 0, "/" ) + "/" + cYY ) ;
        , cCC := if( empty( d ), "19", left( str( year( d ), 4 ), 2 ) ) ;
        , devpos( nRow, nCol + 6 ) ;
        , devout( cCC, cColorGet ) /* update cCC display */ ;
        , if( empty( d ) /* error */ ;
        , ( tone( 200, 3 ), getlist[ 2 ] :exitstate := GE_TOP ) ;
        , nil ) ;
        , .t. ;
        ) ;
        picture "99"
read

set( _SET_CONFIRM, lOldConfirm )

return d

// ---- MyDtoC ----*
//    Convert your date and format-it for the GET

*+
*+
*+    Static Function MyDtoC()
*+
*+    Called from ( getdate2.prg )   1 - function getdate2()
*+
*+
*+
static function MyDtoC( dDate, cDDMM, cCC, cYY, nRow, nCol, cColor )

local cD

if !empty( dDate )
   cD    := dtoc( dDate )
   cDDMM := strtran( left( cD, 5 ), "/", "" )
   cYY   := if( empty( year( dDate ) ), "  ", right( str( year( dDate ) ), 2 ) )
endif

cCC := if( empty( dDate ), "19", left( str( year( dDate ), 4 ), 2 ) )
@ nRow, nCol + 6 say cCC color cColor // The century (display during the GET)        

return .t.

// ---------------------------------SplitColor ---------------------------------
//                                  
//        (cr le 23/2/96, MaJ le 26/05/96 )
//        Decompose une chaine couleur en ses 5 elements (ou plus)
//        Retourne un array de 5 (ou plus) elements
//
//        aColor = SplitColor( [<cColor>] )
//        (par defaut, splitcolor analyse setcolor() )
//
//        exemple : cColorGet := splitColor(cColor)[2]

*+
*+
*+    Function SplitColor()
*+
*+    Called from ( getdate2.prg )   1 - function getdate2()
*+
*+
*+
function SplitColor( cColor )

local nVirg
local i
local arr   := {}

cColor := if( empty( cColor ), setcolor(), cColor )         // DEFAULT TO setcolor()

while ( nVirg := at( ",", cColor ) ) != 0
   aadd( arr, left( cColor, nVirg - 1 ) )
   cColor := substr( cColor, nVirg + 1 )
enddo

aadd( arr, cColor )                     // Le d bout de couleur

for i := len( arr ) + 1 to 6            // On renvoie un array d'au moins 6 el
   aadd( arr, "" )
next

return arr

*+ EOF: GETDATE2.PRG
